package alterrs.jbct.deob;

import static org.objectweb.asm.Opcodes.LDC;

import org.objectweb.asm.tree.AbstractInsnNode;
import org.objectweb.asm.tree.ClassNode;
import org.objectweb.asm.tree.LdcInsnNode;
import org.objectweb.asm.tree.MethodInsnNode;
import org.objectweb.asm.tree.MethodNode;

import alterrs.jbct.JBCT;
import alterrs.jbct.utility.ASMUtil;
import alterrs.jbct.utility.AbstractTransformer;
import alterrs.jbct.utility.ID;

/**
 * 
 * @author Kyle Friz
 * @since  Apr 24, 2016
 */
public class ReflectionDeobfuscator extends AbstractTransformer {
	private int count = 0;

	public ReflectionDeobfuscator() {
		super(true);
	}

	
	/**
	 * Note new RS does not need this deobfuscation, only 500-600ishs
	 */
	@Override
	public void visitMethodInsn(ClassNode c, MethodNode m, MethodInsnNode n) {
		if (n.owner.equals("java/lang/Class") && n.name.equals("forName")) {
			AbstractInsnNode ldc = ASMUtil.previousRealInsn(n.getPrevious());
			
			if (ldc.getOpcode() == LDC) {
				String name = (String) ((LdcInsnNode) ldc).cst;
				
				String newName = JBCT.ctx.module.getRefactorer().getClass(new ID(name));
				
				if (newName != null) {
					((LdcInsnNode) ldc).cst = newName;
					
					count++;
				}
			}
		}
	}

	@Override
	public void onFinish() {
		System.out.println(" ^	Repaired " + count + " reflection invokes!");
	}
}
